# Auto-generated by EclipseNSIS Script Wizard
# 2007-12-25 15:33:44

Name "FlashPioneer Video Chat Client"

# Defines
!define REGKEY "SOFTWARE\$(^Name)"
!define VERSION 1.7
!define COMPANY FlashPioneer
!define URL http://www.flashpioneer.com/chat/index.htm

# MUI defines
!define MUI_ICON "BIN\SRC\modern-install.ico"
!define MUI_WELCOMEFINISHPAGE_BITMAP "BIN\SRC\orange.bmp"
!define MUI_HEADERIMAGE
!define MUI_HEADERIMAGE_RIGHT
!define MUI_HEADERIMAGE_BITMAP "BIN\SRC\orange-r.bmp"
!define MUI_FINISHPAGE_NOAUTOCLOSE
!define MUI_FINISHPAGE_LINK "Visit the FlashPioneer site for the latest update and support"
!define MUI_FINISHPAGE_LINK_LOCATION "http://www.flashpioneer.com/"
!define MUI_FINISHPAGE_RUN "$INSTDIR\chat.exe"
!define MUI_STARTMENUPAGE_REGISTRY_ROOT HKLM
!define MUI_STARTMENUPAGE_REGISTRY_KEY ${REGKEY}
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME StartMenuGroup
!define MUI_STARTMENUPAGE_DEFAULTFOLDER "FlashPioneer Video Chat Client"
!define MUI_UNICON "BIN\SRC\modern-uninstall.ico"
!define MUI_UNFINISHPAGE_NOAUTOCLOSE
!define MUI_ABORTWARNING

# Included files
!include Sections.nsh
!include MUI.nsh
!include XML.nsh

# Variables
Var StartMenuGroup
Var pLanguage
Var pSkin

# Installer pages
!insertmacro MUI_PAGE_WELCOME
!insertmacro MUI_PAGE_COMPONENTS
Page custom SetCustom
!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_STARTMENU Application $StartMenuGroup
!insertmacro MUI_PAGE_INSTFILES
!insertmacro MUI_PAGE_FINISH
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES

# Installer languages
!insertmacro MUI_LANGUAGE "English"

# Installer attributes
OutFile OutPut\ClientSetup.exe
InstallDir "$PROGRAMFILES\FlashPioneer Video Chat Client"
CRCCheck on
XPStyle on
ShowInstDetails show
VIProductVersion 1.7.0.0
VIAddVersionKey ProductName "FlashPioneer Video Chat Client"
VIAddVersionKey ProductVersion "${VERSION}"
VIAddVersionKey CompanyName "${COMPANY}"
VIAddVersionKey CompanyWebsite "${URL}"
VIAddVersionKey FileVersion "${VERSION}"
VIAddVersionKey FileDescription ""
VIAddVersionKey LegalCopyright ""
InstallDirRegKey HKLM "${REGKEY}" Path
ShowUninstDetails show

# Installer sections
!macro CREATE_SMGROUP_SHORTCUT NAME PATH
    Push "${NAME}"
    Push "${PATH}"
    Call CreateSMGroupShortcut
!macroend

Section "Main Program" SEC0000
    SetOutPath $INSTDIR
    SetOverwrite on
    File BIN\SRC\chat.exe
    File ..\..\client\UserIcons.swf
    File ..\..\client\setting.xml
    ;Get Install Options dialog user input
    ReadINIStr $0 "$PLUGINSDIR\component.ini" "Field 3" "State"
    ReadINIStr $1 "$PLUGINSDIR\component.ini" "Field 4" "State"
    
    Call setLanguage
    Call setSkin
    
    SetFileAttributes $INSTDIR\setting.xml NORMAL
    
    ${xml::LoadFile} $INSTDIR\setting.xml $4
    ${xml::GotoPath} "/clientSet/language" $4
    ${xml::SetAttribute} "value" $pLanguage $4
    ${xml::GotoPath} "/clientSet/theme" $4
    ${xml::SetAttribute} "value" $pSkin $4
    ${xml::SaveFile} $INSTDIR\setting.xml $4
    ${xml::Unload}
    
    SetFileAttributes $INSTDIR\setting.xml HIDDEN|SYSTEM|READONLY
    ;;
    SetOutPath $INSTDIR\cartoon\movie
    File ..\..\client\cartoon\movie\*.swf
    SetOutPath $INSTDIR\cartoon\preview
    File ..\..\client\cartoon\preview\*.png
    SetOutPath $INSTDIR\lang
    File ..\..\client\lang\*.xml
    SetOutPath $INSTDIR\themes\blueblack
    File ..\..\client\themes\blueblack\*.swf
    File ..\..\client\themes\blueblack\*.xml
    SetOutPath $INSTDIR\themes\classicRedBlack
    File ..\..\client\themes\classicRedBlack\*.swf
    File ..\..\client\themes\classicRedBlack\*.xml
    SetOutPath $INSTDIR\themes\default
    File ..\..\client\themes\default\*.swf
    File ..\..\client\themes\default\*.xml
    SetOutPath $INSTDIR\themes\emerald
    File ..\..\client\themes\emerald\*.swf
    File ..\..\client\themes\emerald\*.xml
    SetOutPath $INSTDIR\themes\gray
    File ..\..\client\themes\gray\*.swf
    File ..\..\client\themes\gray\*.xml
    SetOutPath $INSTDIR\themes\silver
    File ..\..\client\themes\silver\*.swf
    File ..\..\client\themes\silver\*.xml
    !insertmacro CREATE_SMGROUP_SHORTCUT "FlashPioneer Video Chat Client" $INSTDIR\chat.exe
    WriteRegStr HKLM "${REGKEY}\Components" "Main Program" 1
SectionEnd

Section "Desktop Shortcut" SEC0001
    SetOutPath $DESKTOP
    CreateShortcut "$DESKTOP\FlashPioneer Video Chat Client.lnk" $INSTDIR\chat.exe
    WriteRegStr HKLM "${REGKEY}\Components" "Desktop Shortcut" 1
SectionEnd

Section -post SEC0002
    WriteRegStr HKLM "${REGKEY}" Path $INSTDIR
    SetOutPath $INSTDIR
    WriteUninstaller $INSTDIR\uninstall.exe
    !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
    SetOutPath $SMPROGRAMS\$StartMenuGroup
    CreateShortcut "$SMPROGRAMS\$StartMenuGroup\Uninstall.lnk" $INSTDIR\uninstall.exe
    !insertmacro MUI_STARTMENU_WRITE_END
    WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" DisplayName "$(^Name)"
    WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" DisplayVersion "${VERSION}"
    WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" Publisher "${COMPANY}"
    WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" URLInfoAbout "${URL}"
    WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" DisplayIcon $INSTDIR\uninstall.exe
    WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" UninstallString $INSTDIR\uninstall.exe
    WriteRegDWORD HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" NoModify 1
    WriteRegDWORD HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" NoRepair 1
SectionEnd

# Macro for selecting uninstaller sections
!macro SELECT_UNSECTION SECTION_NAME UNSECTION_ID
    Push $R0
    ReadRegStr $R0 HKLM "${REGKEY}\Components" "${SECTION_NAME}"
    StrCmp $R0 1 0 next${UNSECTION_ID}
    !insertmacro SelectSection "${UNSECTION_ID}"
    GoTo done${UNSECTION_ID}
next${UNSECTION_ID}:
    !insertmacro UnselectSection "${UNSECTION_ID}"
done${UNSECTION_ID}:
    Pop $R0
!macroend

# Uninstaller sections
!macro DELETE_SMGROUP_SHORTCUT NAME
    Push "${NAME}"
    Call un.DeleteSMGroupShortcut
!macroend

Section /o "-un.Desktop Shortcut" UNSEC0001
    Delete /REBOOTOK "$DESKTOP\FlashPioneer Video Chat Client.lnk"
    DeleteRegValue HKLM "${REGKEY}\Components" "Desktop Shortcut"
SectionEnd

Section /o "-un.Main Program" UNSEC0000
    Delete /REBOOTOK "$DESKTOP\FlashPioneer Video Chat Client.lnk"
    !insertmacro DELETE_SMGROUP_SHORTCUT "FlashPioneer Video Chat Client"
    RMDir /r /REBOOTOK $INSTDIR
    DeleteRegValue HKLM "${REGKEY}\Components" "Main Program"
SectionEnd

Section -un.post UNSEC0002
    DeleteRegKey HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)"
    Delete /REBOOTOK "$SMPROGRAMS\$StartMenuGroup\Uninstall.lnk"
    Delete /REBOOTOK $INSTDIR\uninstall.exe
    DeleteRegValue HKLM "${REGKEY}" StartMenuGroup
    DeleteRegValue HKLM "${REGKEY}" Path
    DeleteRegKey /IfEmpty HKLM "${REGKEY}\Components"
    DeleteRegKey /IfEmpty HKLM "${REGKEY}"
    RmDir /REBOOTOK $SMPROGRAMS\$StartMenuGroup
    RmDir /REBOOTOK $INSTDIR
    Push $R0
    StrCpy $R0 $StartMenuGroup 1
    StrCmp $R0 ">" no_smgroup
no_smgroup:
    Pop $R0
SectionEnd

# Installer functions
Function .onInit
    InitPluginsDir
    File /oname=$PLUGINSDIR\component.ini "component.ini"
FunctionEnd

Function CreateSMGroupShortcut
    Exch $R0 ;PATH
    Exch
    Exch $R1 ;NAME
    Push $R2
    StrCpy $R2 $StartMenuGroup 1
    StrCmp $R2 ">" no_smgroup
    SetOutPath $SMPROGRAMS\$StartMenuGroup
    CreateShortcut "$SMPROGRAMS\$StartMenuGroup\$R1.lnk" $R0
no_smgroup:
    Pop $R2
    Pop $R1
    Pop $R0
FunctionEnd

# Uninstaller functions
Function un.onInit
    ReadRegStr $INSTDIR HKLM "${REGKEY}" Path
    !insertmacro MUI_STARTMENU_GETFOLDER Application $StartMenuGroup
    !insertmacro SELECT_UNSECTION "Main Program" ${UNSEC0000}
    !insertmacro SELECT_UNSECTION "Desktop Shortcut" ${UNSEC0001}
FunctionEnd

Function un.DeleteSMGroupShortcut
    Exch $R1 ;NAME
    Push $R2
    StrCpy $R2 $StartMenuGroup 1
    StrCmp $R2 ">" no_smgroup
    Delete /REBOOTOK "$SMPROGRAMS\$StartMenuGroup\$R1.lnk"
no_smgroup:
    Pop $R2
    Pop $R1
FunctionEnd

# Section Descriptions
!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
!insertmacro MUI_DESCRIPTION_TEXT ${SEC0000} "FlashPioneer Video Chat Client main program"
!insertmacro MUI_DESCRIPTION_TEXT ${SEC0001} "Desktop Shortcut"
!insertmacro MUI_FUNCTION_DESCRIPTION_END

#Display the InstallOptions dialog
Function SetCustom
    !insertmacro MUI_HEADER_TEXT "Config Chat Client" "Choose language and skin theme"
    InstallOptions::dialog "$PLUGINSDIR\component.ini"
FunctionEnd

Function setSkin
    StrCmp $1 "Blue Black" blueblack
    StrCmp $1 "Classic Red Black" classicrb
    StrCmp $1 "Emerald" emerald
    StrCmp $1 "Gray" gray
    StrCmp $1 "Silver" silver
    StrCpy $pSkin "default"
    Return
    
    blueblack:
    StrCpy $pSkin "blueblack"
    Return
    classicrb:
    StrCpy $pSkin "classicRedBlack"
    Return
    emerald:
    StrCpy $pSkin "emerald"
    Return
    gray:
    StrCpy $pSkin "gray"
    Return
    silver:
    StrCpy $pSkin "silver"
FunctionEnd

Function setLanguage
    StrCmp $0 "German" German
    StrCmp $0 "French" French
    StrCmp $0 "Korea" Korea
    StrCmp $0 "Simplified Chinese" Schinese
    StrCmp $0 "Traditional Chinese" Tchinese
    StrCpy $pLanguage "en"
    Return
    
    German:
    StrCpy $pLanguage "de"
    Return
    French:
    StrCpy $pLanguage "fr"
    Return
    Korea:
    StrCpy $pLanguage "ko"
    Return
    Schinese:
    StrCpy $pLanguage "zh-CN"
    Return
    Tchinese:
    StrCpy $pLanguage "zh-TW"
FunctionEnd